import React, { useState, useEffect } from 'react';
import { Form, Icon, Input, Button, DatePicker, Select, Card, Row, Col, Pagination, Alert, Table, Avatar, Radio, Modal, Descriptions, notification } from 'antd';
import moment from 'moment';
import request from '../../../utils/request';
import apis from '../../../services/apis';


const { Option } = Select;
// eslint-disable-next-line @typescript-eslint/no-unused-vars
const { Meta } = Card;

/**
 * 调整归属
 *
 * @param {*} props
 * @returns
 */
class ModalAttribution extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
       dataSource: { records: [] },
       visibleData: { visible: false, realtyConsultant: '', buildingId: '', userId: '' },
    }
  }

  // 挂载之后
  componentDidMount() {
    // this.getList({ pageNumber: 1, pageSize: 5 })
  }

  componentDidUpdate(preProps, preState) {
    if (this.props.visibleData.visible !== preState.visibleData.visible) {
      this.getList({ pageNumber: 1, pageSize: 5, buildingId: this.props.visibleData.buildingId })
      // eslint-disable-next-line react/no-did-update-set-state
      this.setState({ visibleData: this.props.visibleData });
    }
  }

  // 弹框确定按钮
  // eslint-disable-next-line react/sort-comp
  handleOk() {
    this.props.onCancel()
  }

  // 弹框取消按钮
  handleCancel() {
    this.props.onCancel()
  }

  getList(params) {
    if (params.buildingId === '' || params.buildingId === null || params.buildingId === undefined) {
      return
    }

    // 网路请求
    request({ ...apis.customer.buildingConsultant, params: { ...params } }).then(res => {
      const records = res.records.filter(f => f.userId !== this.state.visibleData.userId)
      this.setState({ dataSource: { ...res, records, total: res.total - 1 } })
    }).catch(() => {
      // eslint-disable-next-line no-unused-expressions

    })
  }

  openNotificationWithIcon = (type, message) => {
    notification[type]({
      message,
      description:
        '',
    });
  };

   // 分页
  onChange(pageNum) {
    this.getList({ pageNumber: pageNum, pageSize: 5, buildingId: this.props.visibleData.buildingId })
  }

  // 提交
  submitGm(record) {

    console.log('传递之前：', record)
    this.handleCancel()
    this.props.onSuccess({ realtyConsultant: record.userId, name: record.userName })
  }

  render() {
    const columns = [
      // {
      //   title: '编号',
      //   dataIndex: 'personId',
      //   key: 'personId',
      // },
      {
        title: '姓名',
        dataIndex: 'userName',
        key: 'userName',
      },
      {
        title: '电话',
        dataIndex: 'phone',
        key: 'phone',
      },
      {
        title: '部门',
        dataIndex: 'department',
        key: 'department',
      },
      {
        title: '岗位',
        dataIndex: 'position',
        key: 'position',
      },
      {
        title: '操作',
        dataIndex: 'personId',
        key: 'personId',
        // eslint-disable-next-line no-nested-ternary
        render: (_, record) => <>{ this.props.visibleData.realtyConsultant !== record.userId && <Button type="danger" onClick={() => this.submitGm(record)}>确定</Button>}</>,
      },
    ]
    return (
      <>
        <Modal
            title="选择置业顾问"
            width={800}
            destroyOnClose="true"
            footer={null}
            visible={this.state.visibleData.visible}
            // onOk={() => this.handleOk()}
            onCancel={(e) => this.handleCancel(e)}
          >
            <Table rowKey="attribution" dataSource={this.state.dataSource.records} columns={columns} pagination={{ total: this.state.dataSource.total, onChange: e => this.onChange(e) }} />
          </Modal>
      </>
    );
  }
}

export default ModalAttribution
